diff --git a/base/common/src/org/dogtagpki/tps/msg/NewPinRequestMsg.java b/base/common/src/org/dogtagpki/tps/msg/NewPinRequestMsg.java
new file mode 100644
index 0000000..5deac36
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/NewPinRequestMsg.java
@@ -0,0 +1,30 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+
+public class NewPinRequestMsg extends TPSMessage {
+    public NewPinRequestMsg(int min_len, int max_len) {
+
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_NEW_PIN_REQUEST));
+
+        put(MINIMUM_LENGTH_NAME,min_len);
+        put(MAXIMUM_LENGTH_NAME, max_len);
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/NewPinResponseMsg.java b/base/common/src/org/dogtagpki/tps/msg/NewPinResponseMsg.java
new file mode 100644
index 0000000..1607a4e
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/NewPinResponseMsg.java
@@ -0,0 +1,27 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+
+public class NewPinResponseMsg  extends TPSMessage {
+    public NewPinResponseMsg(String new_pin) {
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_NEW_PIN_RESPONSE));
+        put(NEW_PIN_NAME,new_pin);
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/SecureIdRequestMsg.java b/base/common/src/org/dogtagpki/tps/msg/SecureIdRequestMsg.java
new file mode 100644
index 0000000..c03b3d7
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/SecureIdRequestMsg.java
@@ -0,0 +1,30 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+
+public class SecureIdRequestMsg extends TPSMessage {
+    public SecureIdRequestMsg(int pin_required, int next_value) {
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_SECUREID_REQUEST));
+
+        put(PIN_REQUIRED_NAME,pin_required);
+        put(NEXT_VALUE_NAME, next_value);
+
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/SecureIdResponseMsg.java b/base/common/src/org/dogtagpki/tps/msg/SecureIdResponseMsg.java
new file mode 100644
index 0000000..507a46f
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/SecureIdResponseMsg.java
@@ -0,0 +1,28 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+public class SecureIdResponseMsg extends TPSMessage {
+    public SecureIdResponseMsg(String value, String pin) {
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_SECUREID_RESPONSE));
+
+        put(VALUE_NAME,value);
+        put(PIN_NAME,pin);
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/StatusUpdateRequestMsg.java b/base/common/src/org/dogtagpki/tps/msg/StatusUpdateRequestMsg.java
new file mode 100644
index 0000000..12009fd
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/StatusUpdateRequestMsg.java
@@ -0,0 +1,36 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+public class StatusUpdateRequestMsg extends TPSMessage {
+    public StatusUpdateRequestMsg(int status, String info) {
+
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_STATUS_UPDATE_REQUEST));
+        put(STATUS_NAME, status);
+        put(INFO_NAME, info);
+
+    }
+
+    public static void main(String[] args) {
+
+        StatusUpdateRequestMsg req = new StatusUpdateRequestMsg(10, "PROGRESS_APPLET_BLOCK");
+        System.out.println(req.encode());
+
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/StatusUpdateResponseMsg.java b/base/common/src/org/dogtagpki/tps/msg/StatusUpdateResponseMsg.java
new file mode 100644
index 0000000..7dc0727
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/StatusUpdateResponseMsg.java
@@ -0,0 +1,29 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+
+public class StatusUpdateResponseMsg extends TPSMessage {
+
+    public StatusUpdateResponseMsg(int status) {
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_STATUS_UPDATE_RESPONSE));
+        put(STATUS_NAME,status);
+    }
+
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/TPSMessage.java b/base/common/src/org/dogtagpki/tps/msg/TPSMessage.java
index 39af93c..16fec1d 100644
--- a/base/common/src/org/dogtagpki/tps/msg/TPSMessage.java
+++ b/base/common/src/org/dogtagpki/tps/msg/TPSMessage.java
@@ -441,7 +441,7 @@ public class TPSMessage {
 
         switch (val) {
         case MSG_BEGIN_OP:
-            result = new BeginOp(op_val, extsMap);
+            result = new BeginOpMsg(op_val, extsMap);
 
             break;
         case MSG_ASQ_REQUEST:
@@ -454,7 +454,7 @@ public class TPSMessage {
             break;
         case MSG_EXTENDED_LOGIN_RESPONSE:
             result =
-                new ExtendedLoginResponse(op_val,
+                new ExtendedLoginResponseMsg(op_val,
                     get(SCREEN_NAME_NAME),
                     get(PASSWORD_NAME),
                     extsMap);
@@ -463,7 +463,7 @@ public class TPSMessage {
             break;
         case MSG_LOGIN_RESPONSE:
             result =
-                new LoginResponse(get(SCREEN_NAME_NAME),
+                new LoginResponseMsg(get(SCREEN_NAME_NAME),
                     get(PASSWORD_NAME));
             break;
         case MSG_NEW_PIN_REQUEST:
@@ -482,12 +482,12 @@ public class TPSMessage {
             CMS.debug("statusValue: " + statusValue);
             int statusInt = Integer.parseInt(statusValue);
             CMS.debug("statusInt: " + statusInt);
-            result = new StatusUpdateResponse(statusInt);
+            result = new StatusUpdateResponseMsg(statusInt);
             break;
         case MSG_TOKEN_PDU_REQUEST:
             break;
         case MSG_TOKEN_PDU_RESPONSE:
-            result = new TokenPDUResponse(encode());
+            result = new TokenPDUResponseMsg(encode());
             break;
         default:
             //Something was garbled with the message coming in
@@ -519,7 +519,7 @@ public class TPSMessage {
 
     public static void main(String[] args) throws IOException {
         String encoded = "s=204&msg_type=2&operation=5&extensions=tokenType%3DuserKey%26clientVersion%3DESC+1%2E0%2E1%26tokenATR%3D3BFF1400FF8131FE458025A00000005657534336353003003B%26statusUpdate%3Dtrue%26extendedLoginRequest%3Dtrue%26";
-        BeginOp testMessage = (BeginOp) TPSMessage.createMessage(encoded);
+        BeginOpMsg testMessage = (BeginOpMsg) TPSMessage.createMessage(encoded);
         System.out.println("Encoded msg: " + testMessage.encode());
         System.out.println("msg Extensions: " + testMessage.getExtensions());
 
diff --git a/base/common/src/org/dogtagpki/tps/msg/TokenPDURequestMsg.java b/base/common/src/org/dogtagpki/tps/msg/TokenPDURequestMsg.java
new file mode 100644
index 0000000..42fcf25
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/TokenPDURequestMsg.java
@@ -0,0 +1,61 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+import org.dogtagpki.tps.apdu.APDU;
+import org.dogtagpki.tps.apdu.SelectAPDU;
+import org.dogtagpki.tps.main.TPSBuffer;
+import org.dogtagpki.tps.main.Util;
+
+public class TokenPDURequestMsg extends TPSMessage {
+
+    public TokenPDURequestMsg(APDU apdu) {
+
+        put(MSG_TYPE_NAME, msgTypeToInt(MsgType.MSG_TOKEN_PDU_REQUEST));
+
+        if (apdu != null) {
+
+            TPSBuffer encoding = apdu.getEncoding();
+            int apduSize = encoding.size();
+
+            String apdu_value = Util.uriEncodeInHex(encoding.toBytesArray());
+
+            put(PDU_SIZE_NAME, apduSize);
+            put(PDU_DATA_NAME, apdu_value);
+
+        }
+
+    }
+
+    public static void main(String[] args) {
+
+        SelectAPDU apdu = null;
+
+        byte[] select_aid = { (byte) 0xa0, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0 };
+
+        TPSBuffer select = new TPSBuffer(select_aid);
+
+        apdu = new SelectAPDU((byte) 0x4, (byte) 0x0, select);
+
+        TokenPDURequestMsg request = new TokenPDURequestMsg(apdu);
+
+        System.out.println(request.encode());
+
+    }
+
+}
diff --git a/base/common/src/org/dogtagpki/tps/msg/TokenPDUResponseMsg.java b/base/common/src/org/dogtagpki/tps/msg/TokenPDUResponseMsg.java
new file mode 100644
index 0000000..60e079b
--- /dev/null
+++ b/base/common/src/org/dogtagpki/tps/msg/TokenPDUResponseMsg.java
@@ -0,0 +1,68 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.msg;
+
+import org.dogtagpki.tps.apdu.APDUResponse;
+import org.dogtagpki.tps.main.TPSBuffer;
+import org.dogtagpki.tps.main.Util;
+
+public class TokenPDUResponseMsg extends TPSMessage {
+
+    private APDUResponse response;
+
+    public TokenPDUResponseMsg(String message) {
+
+        super(message);
+        response = null;
+
+        String size = get(PDU_SIZE_NAME);
+        String apduData = get(PDU_DATA_NAME);
+
+        int sizeI = Integer.parseInt(size);
+
+        byte[] decoded_pdu_data = Util.uriDecodeFromHex(apduData);
+
+        if (decoded_pdu_data.length == sizeI) {
+
+            TPSBuffer responseBuffer = new TPSBuffer(decoded_pdu_data);
+
+            response = new APDUResponse(responseBuffer);
+
+        }
+
+    }
+
+    public APDUResponse getResponseAPDU() {
+        return response;
+    }
+
+    public static void main(String[] args) {
+
+        String pdu_data = "s=46&msg_type=10&pdu_size=6&pdu_data=R%B3F%85%90%00";
+        TokenPDUResponseMsg msg = new TokenPDUResponseMsg(pdu_data);
+
+        System.out.println(msg.encode());
+
+        String pdu_data1 = "s=38&msg_type=10&pdu_size=2&pdu_data=%90%00";
+        TokenPDUResponseMsg msg1 = new TokenPDUResponseMsg(pdu_data1);
+
+        System.out.println(msg1.encode());
+
+    }
+
+}
diff --git a/base/tps-tomcat/src/org/dogtagpki/server/tps/TPSSession.java b/base/tps-tomcat/src/org/dogtagpki/server/tps/TPSSession.java
index 31b6c41..aefdb81 100644
--- a/base/tps-tomcat/src/org/dogtagpki/server/tps/TPSSession.java
+++ b/base/tps-tomcat/src/org/dogtagpki/server/tps/TPSSession.java
@@ -19,11 +19,12 @@ package org.dogtagpki.server.tps;
 
 import java.io.IOException;
 
+import org.dogtagpki.server.tps.processor.TPSEnrollProcessor;
 import org.dogtagpki.server.tps.processor.TPSProcessor;
 import org.dogtagpki.tps.TPSConnection;
 import org.dogtagpki.tps.main.TPSException;
-import org.dogtagpki.tps.msg.BeginOp;
-import org.dogtagpki.tps.msg.EndOp;
+import org.dogtagpki.tps.msg.BeginOpMsg;
+import org.dogtagpki.tps.msg.EndOpMsg;
 import org.dogtagpki.tps.msg.TPSMessage;
 
 import com.netscape.certsrv.apps.CMS;
@@ -77,7 +78,7 @@ public class TPSSession {
     }
 
     public void process() throws IOException {
-        EndOp.TPSStatus status = EndOp.TPSStatus.STATUS_NO_ERROR;
+        EndOpMsg.TPSStatus status = EndOpMsg.TPSStatus.STATUS_NO_ERROR;
         CMS.debug("In TPSSession.process()");
 
         TPSMessage firstMsg = read();
@@ -89,17 +90,24 @@ public class TPSSession {
             throw new IOException("Wrong first message type read in TPSSession.process!");
         }
 
-        int result = EndOp.RESULT_GOOD;
+        int result = EndOpMsg.RESULT_ERROR;
+        BeginOpMsg beginOp = (BeginOpMsg) firstMsg;
         try {
 
             switch (op_type) {
             case OP_FORMAT:
 
+                //Assume success, processor will indicate otherwise
+                result = EndOpMsg.RESULT_GOOD;
                 TPSProcessor processor = new TPSProcessor(this);
-                BeginOp beginOp = (BeginOp) firstMsg;
                 processor.process(beginOp);
+                break;
 
             case OP_ENROLL:
+                //Assume success, processor will indicate otherwise
+                result = EndOpMsg.RESULT_GOOD;
+                TPSEnrollProcessor enrollProcessor = new TPSEnrollProcessor(this);
+                enrollProcessor.process(beginOp);
                 break;
             case OP_RENEW:
                 break;
@@ -117,7 +125,7 @@ public class TPSSession {
             //Get the status from the exception and return it to the client.
             CMS.debug("TPSSession.process: Message processing failed: " + e);
             status = e.getStatus();
-            result = EndOp.RESULT_ERROR;
+            result = EndOpMsg.RESULT_ERROR;
         } catch (IOException e) {
             CMS.debug("TPSSession.process: IO error happened during processing: " + e);
             // We get here we are done.
@@ -125,7 +133,7 @@ public class TPSSession {
 
         }
 
-        EndOp endOp = new EndOp(firstMsg.getOpType(), result, status);
+        EndOpMsg endOp = new EndOpMsg(firstMsg.getOpType(), result, status);
         write(endOp);
 
         CMS.debug("TPSSession.process: leaving: result: " + result + " status: " + status);
diff --git a/base/tps-tomcat/src/org/dogtagpki/server/tps/channel/SecureChannel.java b/base/tps-tomcat/src/org/dogtagpki/server/tps/channel/SecureChannel.java
index 22ee968..67ab08b 100644
--- a/base/tps-tomcat/src/org/dogtagpki/server/tps/channel/SecureChannel.java
+++ b/base/tps-tomcat/src/org/dogtagpki/server/tps/channel/SecureChannel.java
@@ -25,14 +25,17 @@ import org.dogtagpki.tps.apdu.APDUResponse;
 import org.dogtagpki.tps.apdu.DeleteFileAPDU;
 import org.dogtagpki.tps.apdu.ExternalAuthenticateAPDU;
 import org.dogtagpki.tps.apdu.ExternalAuthenticateAPDU.SecurityLevel;
+import org.dogtagpki.tps.apdu.GenerateKeyAPDU;
+import org.dogtagpki.tps.apdu.GenerateKeyECCAPDU;
 import org.dogtagpki.tps.apdu.InstallAppletAPDU;
 import org.dogtagpki.tps.apdu.InstallLoadAPDU;
 import org.dogtagpki.tps.apdu.LoadFileAPDU;
+import org.dogtagpki.tps.apdu.ReadObjectAPDU;
 import org.dogtagpki.tps.apdu.SetIssuerInfoAPDU;
 import org.dogtagpki.tps.main.TPSBuffer;
 import org.dogtagpki.tps.main.TPSException;
 import org.dogtagpki.tps.main.Util;
-import org.dogtagpki.tps.msg.EndOp.TPSStatus;
+import org.dogtagpki.tps.msg.EndOpMsg.TPSStatus;
 import org.mozilla.jss.pkcs11.PK11SymKey;
 
 import com.netscape.certsrv.apps.CMS;
@@ -54,14 +57,17 @@ public class SecureChannel {
     private TPSBuffer hostChallenge;
     private TPSBuffer hostCryptogram;
     private TPSBuffer icv;
+    private TPSBuffer keyInfoData;
     private SecurityLevel secLevel;
 
     public SecureChannel(TPSProcessor processor, PK11SymKey sessionKey, PK11SymKey encSessionKey, TPSBuffer drmDesKey,
             TPSBuffer kekDesKey, TPSBuffer keyCheck, TPSBuffer keyDiversificationData, TPSBuffer cardChallenge,
-            TPSBuffer cardCryptogram, TPSBuffer hostChallenge, TPSBuffer hostCryptogram) throws TPSException {
+            TPSBuffer cardCryptogram, TPSBuffer hostChallenge, TPSBuffer hostCryptogram, TPSBuffer keyInfoData)
+            throws TPSException {
 
         if (processor == null || sessionKey == null | encSessionKey == null || keyDiversificationData == null
-                || cardChallenge == null || cardCryptogram == null || hostChallenge == null || hostCryptogram == null) {
+                || cardChallenge == null || cardCryptogram == null || hostChallenge == null || hostCryptogram == null
+                || keyInfoData == null) {
             throw new TPSException("SecureChannel.SecureChannel: Invalid data in constructor!",
                     TPSStatus.STATUS_ERROR_SECURE_CHANNEL);
         }
@@ -78,6 +84,7 @@ public class SecureChannel {
         this.hostChallenge = hostChallenge;
         this.hostCryptogram = hostCryptogram;
         this.icv = new TPSBuffer(8);
+        this.keyInfoData = keyInfoData;
 
         this.secLevel = SecurityLevel.SECURE_MSG_MAC_ENC;
         //ToDo: Write method that reads this from the config
@@ -394,4 +401,121 @@ public class SecureChannel {
         return cardCryptogram;
     }
 
+    public TPSBuffer getKeyInfoData() {
+        return keyInfoData;
+    }
+
+    public TPSBuffer readObject(TPSBuffer objectID, int offset, int len) throws TPSException, IOException {
+
+        CMS.debug("SecureChannel.readObject: entering ...");
+
+        if (objectID == null || len == 0) {
+            throw new TPSException("SecureChannel.readObject: invalid input data.",
+                    TPSStatus.STATUS_ERROR_READ_OBJECT_PDU);
+        }
+
+        final int MAX_READ_BUFFER_SIZE = 0xd0;
+
+        ReadObjectAPDU read = null;
+        TPSBuffer result = new TPSBuffer();
+
+        int cur_read = 0;
+        int cur_offset = 0;
+        int sum = 0;
+
+        if (len > MAX_READ_BUFFER_SIZE) {
+            cur_offset = offset;
+            cur_read = MAX_READ_BUFFER_SIZE;
+        } else {
+            cur_offset = offset;
+            cur_read = len;
+        }
+
+        while (sum < len) {
+
+            read = new ReadObjectAPDU(objectID.toBytesArray(), cur_offset, cur_read);
+            computeAPDU(read);
+
+            APDUResponse response = processor.handleAPDURequest(read);
+
+            if (!response.checkResult()) {
+                CMS.debug("SecureChannel.readObject: bad apdu return!");
+                throw new TPSException("SecureChannel.installApplett. Failed in middle of readObject.",
+                        TPSStatus.STATUS_ERROR_SECURE_CHANNEL);
+            }
+
+            TPSBuffer resp = response.getResultDataNoCode();
+
+            result.add(resp);
+
+            sum += resp.size();
+            cur_offset += resp.size();
+
+            if ((len - sum) < MAX_READ_BUFFER_SIZE) {
+                cur_read = len - sum;
+            } else {
+                cur_read = MAX_READ_BUFFER_SIZE;
+            }
+
+        }
+
+        return result;
+    }
+
+    public int startEnrollment(int pe1, int pe2, TPSBuffer wrappedChallenge, TPSBuffer keyCheck, int algorithm,
+            int keySize, int option) throws TPSException, IOException {
+
+        if (wrappedChallenge == null) {
+            throw new TPSException("SecureChannel.startEnrollment. Bad input data.",
+                    TPSStatus.STATUS_ERROR_MAC_ENROLL_PDU);
+        }
+
+        CMS.debug("SecureChannel.startEnrollment: entering ...");
+
+        boolean isECC = processor.getTPSEngine().isAlgorithmECC(algorithm);
+
+        GenerateKeyAPDU generate_key_apdu = null;
+        GenerateKeyECCAPDU generate_ecc_key_apdu = null;
+
+        APDUResponse response = null;
+        if (isECC) {
+
+            generate_ecc_key_apdu = new GenerateKeyECCAPDU((byte) pe1, (byte) pe2, (byte) algorithm, keySize,
+                    (byte) option, (byte) 0, wrappedChallenge, keyCheck);
+
+            computeAPDU(generate_ecc_key_apdu);
+
+            response = processor.handleAPDURequest(generate_ecc_key_apdu);
+
+            if (!response.checkResult()) {
+                throw new TPSException("SecureChannel.startEnrollment. Failed generate key on token.",
+                        TPSStatus.STATUS_ERROR_MAC_ENROLL_PDU);
+            }
+
+        } else {
+
+            generate_key_apdu = new GenerateKeyAPDU((byte) pe1, (byte) pe2, (byte) algorithm, keySize,
+                    (byte) option, (byte) 0, wrappedChallenge, keyCheck);
+
+            computeAPDU(generate_key_apdu);
+
+            response = processor.handleAPDURequest(generate_key_apdu);
+
+            if (!response.checkResult()) {
+                throw new TPSException("SecureChannel.startEnrollment. Failed generate key on token.",
+                        TPSStatus.STATUS_ERROR_MAC_ENROLL_PDU);
+            }
+
+        }
+
+        TPSBuffer data = response.getData();
+
+        int size = data.getIntFrom2Bytes(0);
+
+        CMS.debug("SecureChannel.startEnrollment: returning key size: " + size);
+
+        return size;
+
+    }
+
 }
diff --git a/base/tps-tomcat/src/org/dogtagpki/server/tps/engine/TPSEngine.java b/base/tps-tomcat/src/org/dogtagpki/server/tps/engine/TPSEngine.java
index 71239a4..2d6b09e 100644
--- a/base/tps-tomcat/src/org/dogtagpki/server/tps/engine/TPSEngine.java
+++ b/base/tps-tomcat/src/org/dogtagpki/server/tps/engine/TPSEngine.java
@@ -21,13 +21,22 @@ import org.dogtagpki.server.tps.cms.TKSComputeSessionKeyResponse;
 import org.dogtagpki.server.tps.cms.TKSRemoteRequestHandler;
 import org.dogtagpki.tps.main.TPSBuffer;
 import org.dogtagpki.tps.main.TPSException;
-import org.dogtagpki.tps.msg.EndOp.TPSStatus;
+import org.dogtagpki.tps.msg.EndOpMsg.TPSStatus;
 
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.EBaseException;
 
 public class TPSEngine {
 
+    public enum RA_Algs {
+        ALG_RSA ,
+        ALG_RSA_CRT ,
+        ALG_DSA ,
+        ALG_EC_F2M ,
+        ALG_EC_FP
+};
+
+
     public static final String CFG_DEBUG_ENABLE = "logging.debug.enable";
     public static final String CFG_DEBUG_FILENAME = "logging.debug.filename";
     public static final String CFG_DEBUG_LEVEL = "logging.debug.level";
@@ -85,6 +94,9 @@ public class TPSEngine {
     public static final String CFG_CHANNEL_DEFKEY_INDEX = "channel.defKeyIndex";
     public static final String CFG_ISSUER_INFO_ENABLE = "issuerinfo.enable";
     public static final String CFG_ISSUER_INFO_VALUE = "issuerinfo.value";
+    public static final String CFG_UPDATE_APPLET_ENCRYPTION = "update.applet.encryption";
+    public static final String CFG_UPDATE_APPLET_ENABLE = "update.applet.enable";
+    public static final String CFG_SYMM_KEY_UPGRADE_ENABLED = "update.symmetricKeys.enable";
 
     /* default values */
     public static final String CFG_DEF_CARDMGR_INSTANCE_AID = "A0000000030000";
@@ -99,6 +111,11 @@ public class TPSEngine {
     public static final int CFG_CHANNEL_DEF_INSTANCE_SIZE = 18000;
     public static final int CFG_CHANNEL_DEF_APPLET_MEMORY_SIZE = 5000;
 
+    /* token enrollment values */
+    public static final String CFG_KEYGEN_KEYTYPE_NUM = "keyGen.keyType.num";
+    public static final String CFG_KEYGEN_KEYTYPE_VALUE = "keyGen.keyType.value";
+    public static final String CFG_SERVER_KEYGEN_ENABLE = "serverKeygen.enable";
+
 
     /* External reg values */
 
@@ -109,6 +126,15 @@ public class TPSEngine {
     public static final String OP_FORMAT_PREFIX = "op.format";
     public static final String CFG_PROFILE_RESOLVER = "tokenProfileResolver";
     public static final String CFG_DEF_FORMAT_PROFILE_RESOLVER = "formatMappingResolver";
+    public static final String CFG_DEF_ENROLL_PROFILE_RESOLVER = "enrollMappingResolver";
+    public static final String CFG_DEF_PIN_RESET_PROFILE_RESOLVER = "pinResetMappingResolver";
+    public static final String OP_ENROLL_PREFIX = "op.enroll";
+    public static final String OP_PIN_RESET_PREFIX = "op.pinReset";
+    public static final String ENROLL_OP = "enroll";
+    public static final String FORMAT_OP = "format";
+
+    public static String CFG_OVERWRITE = "overwrite";
+    public static String PIN_RESET_OP = "pin_reset";
 
     public void init() {
         //ToDo
@@ -166,4 +192,50 @@ public class TPSEngine {
 
     }
 
+    public boolean raForceTokenFormat(String cuid) {
+        // TODO Auto-generated method stub
+        return false;
+    }
+
+    public boolean isAlgorithmECC(int algorithm) {
+
+        RA_Algs algEnum = intToRAAlgs(algorithm);
+
+        boolean isECC = false;
+
+        if(algEnum == RA_Algs.ALG_EC_F2M || algEnum == RA_Algs.ALG_EC_FP) {
+            isECC = true;
+        }
+
+        CMS.debug("TPSEngine.isAlgorithmECC: result: " + isECC);
+        return isECC;
+
+    }
+
+    public static RA_Algs intToRAAlgs(int alg) {
+
+        RA_Algs def = RA_Algs.ALG_RSA;
+
+        switch(alg) {
+
+        case 1:
+            return RA_Algs.ALG_RSA;
+
+        case 2:
+            return RA_Algs.ALG_RSA_CRT;
+        case 3:
+            return RA_Algs.ALG_DSA;
+        case 4:
+            return RA_Algs.ALG_EC_F2M;
+        case 5:
+            return RA_Algs.ALG_EC_FP;
+
+            default:
+                return def;
+
+        }
+
+
+    }
+
 }
diff --git a/base/tps-tomcat/src/org/dogtagpki/server/tps/main/AttributeSpec.java b/base/tps-tomcat/src/org/dogtagpki/server/tps/main/AttributeSpec.java
new file mode 100644
index 0000000..444f22c
--- /dev/null
+++ b/base/tps-tomcat/src/org/dogtagpki/server/tps/main/AttributeSpec.java
@@ -0,0 +1,71 @@
+package org.dogtagpki.server.tps.main;
+
+import org.dogtagpki.tps.main.TPSBuffer;
+
+public class AttributeSpec {
+
+    public AttributeSpec() {
+    }
+
+    private long id;
+    private byte type;
+    private TPSBuffer data;
+
+    public void setAttributeID(long attribute_id) {
+        id = attribute_id;
+    }
+
+    public long getAttributeID() {
+        return id;
+    }
+
+    public void setType(byte type) {
+        this.type = type;
+    }
+
+    public byte getType() {
+        return type;
+    }
+
+    public void setData(TPSBuffer data) {
+        this.data = data;
+
+    }
+
+    public TPSBuffer getData() {
+        TPSBuffer theData = new TPSBuffer();
+        theData.addLong4Bytes(id);
+        theData.add(type);
+
+        if (type == 0) { /* String */
+            theData.addInt2Bytes(data.size());
+        }
+        theData.add(data);
+        return theData;
+    }
+
+    public TPSBuffer getValue() {
+        return data;
+    }
+
+    public static AttributeSpec parse(TPSBuffer b, int offset) {
+        AttributeSpec o = new AttributeSpec();
+
+        long id = b.getLongFrom4Bytes(offset);
+
+        o.setAttributeID(id);
+
+        o.setType(b.at(offset + 4));
+        // DatatypeString contains two bytes for AttributeLen of AttributeData
+        TPSBuffer theData;
+        if (o.getType() == (byte) 0)
+            theData = b.substr(offset + 5 + 2, b.size() - 5 - 2);
+        else
+            theData = b.substr(offset + 5, b.size() - 5);
+
+        o.setData(theData);
+        return o;
+
+    }
+
+}
